// 2006-12-16 programmeerimisvistlus
// lesanne: DOOMINOKIVID
// Autor: Ahto Truu
// Testitud: GCC 3.2.3 / MinGW32

#include <fstream>
#include <set>
using namespace std;

ifstream fsis("dom.sis"); // sisendfail
ofstream fval("dom.val"); // vljundfail

typedef pair<int, int> kivi;
typedef set<kivi> hulk;

hulk h; // kivide hulk

int main() {
    int n, k;
    fsis >> n >> k;
    // teeme N-doomino tiskomplekti
    for (int a = 0; a <= n; ++a)
        for (int b = a; b <= n; ++b)
            h.insert(make_pair(a, b));
    // nd eemaldame sisendis antud K kivi
    for (int i = 0; i < k; ++i) {
        int a, b;
        fsis >> a >> b;
        // eemaldame mlemad variandid
        h.erase(make_pair(a, b));
        h.erase(make_pair(b, a));
    }
    // teeme vljundi
    fval << h.size() << endl;
    for (hulk::iterator i = h.begin(); i != h.end(); ++i)
        fval << i->first << " " << i->second << endl;
    // kogu lugu :)
    return 0;
}
