{ 2006-12-16 programmeerimisvistlus                                        }
{ lesanne: VALGUSKIIR                                                      }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
   sisf = 'kiir.sis';                                    { sisendfaili nimi }
   valf = 'kiir.val';                                   { vljundfaili nimi }
   maxr = 50;                                      { maksimaalne ridade arv }
   maxv = 50;                                    { maksimaalne veergude arv }

var
   f : text;                                           { sisend/vljundfail }
   r, v : integer;                                          { karbi mtmed }
   a : array [1..maxr] of string[maxv];                   { karbi kirjeldus }
   s, t : integer;                { kiire sisenemis- ja vljumisaugu number }
   n : integer;                                         { peegeldumiste arv }
   x, y : integer;                             { "kvandi" hetkekoordinaadid }
   dx, dy : integer;                               { "kvandi" liikumissuund }
   i : integer;

begin
   { loeme sisendi }
   assign(f, sisf); reset(f);
   readln(f, r, v);
   for i := 1 to r do
      readln(f, a[i]);
   readln(f, s);
   close(f);

   { teisendame sisenemispunkti algpositsiooniks ja liikumissuunaks }
   if s <= v then begin
      x := s; y := 1;                      { kiir siseneb lemisest kljest }
      dx := 0; dy := 1;                               { ja liigub allapoole }
   end else if s - v <= r then begin
      x := v; y := s - v;                   { kiir siseneb paremast kljest }
      dx := -1; dy := 0;                               { ja liigub vasakule }
   end else if s - v - r <= v then begin
      x := v - (s - v - r) + 1; y := r;    { kiir siseneb alumisest kljest }
      dx := 0; dy := -1;                              { ja liigub lespoole }
   end else if s - v - r - v <= r then begin
      x := 1; y := r - (s - v - r - v) + 1; { kiir siseneb vasakust kljest }
      dx := 1; dy := 0;                                { ja liigub paremale }
   end;

   { modelleerime liikumist, kuni kiir psib karbis }
   n := 0;                                   { veel pole peegeldumisi olnud }
   repeat
      if a[y][x] = '\' then begin       { peegeldumine hes suunas peeglist }
         i := dx; dx := dy; dy := i;           { peegeldumine muudab suunda }
         n := n + 1;                                { loendame peegeldumise }
      end else if a[y][x] = '/' then begin      { ja teises suunas peeglist }
         i := -dx; dx := -dy; dy := i;         { peegeldumine muudab suunda }
         n := n + 1;                                { loendame peegeldumise }
      end;
      x := x + dx; y := y + dy;             { liigume he ruudu vrra edasi }
   until (x < 1) or (x > v) or (y < 1) or (y > r);

   { teisendame lpp-positsiooni vljumispunktiks }
   if y < 1 then begin                      { kiir vljus lemisest kljest }
      t := x;
   end else if x > v then begin              { kiir vljus paremast kljest }
      t := v + y;
   end else if y > r then begin             { kiir vljus alumisest kljest }
      t := v + r + (v - x) + 1;
   end else if x < 1 then begin              { kiir vljus vasakust kljest }
      t := v + r + v + (r - y) + 1;
   end;

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   writeln(f, n);
   writeln(f, t);
   close(f);
end.
