{ 2006-12-16 programmeerimisvistlus                                        }
{ lesanne: PANK                                                            }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
   sisf = 'pank.sis';                                    { sisendfaili nimi }
   valf = 'pank.val';                                   { vljundfaili nimi }
   maxk = 25;                                     { maksimaalne kassade arv }
   maxt = 25;                                    { maksimaalne teenuste arv }

var
   fsis, fval : text;                              { sisend- ja vljundfail }
   k, t : integer;                                  { kassade, teenuste arv }
   kt : array [1..maxk, 1..maxt] of boolean;             { kassade teenused }
   kv : array [1..maxk] of longint;  { kassade vabanemise ajad, NB! longint }
   n : integer;                                             { klientide arv }
   a, b, c : integer;                                      { kliendi andmed }
   i, j, u : integer;

begin
   assign(fsis, sisf); reset(fsis);
   assign(fval, valf); rewrite(fval);

   { loeme kassade andmed }
   readln(fsis, k, t);
   for i := 1 to k do begin
      for j := 1 to t do
         kt[i, j] := false;
      kv[i] := 0;
   end;
   for i := 1 to k do begin
      read(fsis, t);
      for j := 1 to t do begin
         read(fsis, u);
         kt[i, u] := true;
      end;
      readln(fsis);
   end;

   { loeme ja ttleme klientide andmed }
   readln(fsis, n);
   for i := 1 to n do begin
      readln(fsis, a, b, c);
      u := 0;
      for j := 1 to k do                            { otsime sobivat kassat }
         if kt[j, b] then                   { kassa pakub vajalikku teenust }
            if u = 0 then                      { see on esimene sobiv kassa }
               u := j                                       { jtame meelde }
            else if kv[u] > a then                { kui klient peaks ootama }
               if kv[j] < kv[u] then           { ja uus kassa vabaneb varem }
                  u := j;                       { siis on see parem variant }
      assert(u > 0, 'VIGA: kski kassa ei paku teenust');
      if kv[u] < a then                          { kui kassa seisab thjalt }
         kv[u] := a;                             { siis kliendi saabumiseni }
      writeln(fval, u, ' ', kv[u]);     { klient saab kassasse hetkel kv[u] }
      kv[u] := kv[u] + c;                        { kassa uus vabanemise aeg }
   end;

   close(fsis);
   close(fval);
end.
