/* 2006-12-16 programmeerimisvistlus                                       */
/* lesanne: PREFIKSPAKKIMINE                                               */
/* Autor: Heno Ivanov                                                       */
/* Testitud: GCC 3.2.3 / WinGW32                                            */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define PIKKUS 32
#define SONASTIK 10000

char sonad[SONASTIK][PIKKUS];

int common_prefix(char *v1, char *v2) {
	int r=0;
	while ((*v1 != '\0') && (*v2 != '\0') && (*v1++ == *v2++))
		r++;
	return r;
}

main() {
	FILE *sf,*vf;
	char *prev = "";
	int n,i;
	sf = fopen("pref.sis","r");
	vf = fopen("pref.val","w");
	fscanf(sf,"%d\n",&n);
	for (i=0;i<n;i++) {
		fscanf(sf,"%s\n",sonad[i]);
	}
	qsort(sonad,n,PIKKUS,strcmp);
	for (i=0;i<n;i++) {
		int cp = common_prefix(prev,sonad[i]);
		if (cp > 0) {
			fprintf(vf,"%d%s\n",cp,sonad[i] + cp );
		} else {
			fprintf(vf,"%s\n",sonad[i]);
		}
		prev = sonad[i];
	}
	fclose(sf);
	fclose(vf);
}
