// 2006-12-16 programmeerimisvistlus
// lesanne: PREFIKSPAKKIMINE
// Autor: Heno Ivanov, Ahto Truu
// Testitud: GCC 3.2.3 / WinGW32

#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

ifstream sf("pref.sis");
ofstream vf("pref.val");

int common_prefix(const string & v1, const string & v2) {
	int r = 0;
	while (r < v1.size() && r < v2.size() && v1[r] == v2[r])
		++r;
	return r;
}

int main() {
	vector<string> v;
	int n;
	string s;
	sf >> n;
	for (int i = 0; i < n; ++i) {
		sf >> s;
		v.push_back(s);
	}
	sort(v.begin(), v.end());
	s = ""; // s algvrtus, mis aitab vljundi esimese rea igesti arvutada
	for (int i = 0; i < n; ++i) {
		int cp = common_prefix(s, v[i]);
		if (cp > 0)
			vf << cp;
		vf << v[i].substr(cp) << endl;
		s = v[i];
	}
	return 0;
}
