// 2006-12-16 programmeerimisvistlus
// lesanne: TSIRKUS
// Autor: Laur Tooming
// Testitud: GCC 3.2.3 / MinGW32

#include <fstream>
using namespace std;

int n,         //ruutude arv
ntunnel,       //tunnelite arv
tunnel[1001],  //kuhu viivad tunnelid ruutudelt
kaugus[1001],  //mitme kiguga ruutudele pseb algruudult
taring[1001],  //viimase tringuviske tulemus
eelm[1001],    //eelmine ruut, kus oldi
tee[1001];     //tringuvisete jada teel algusest lppu

int jk[1001],  //jrjekord laiuti otsingu jaoks
jkalg, jklopp; //jrjekorra alguse ja lpu indeks

ifstream sisf("ts.sis");
ofstream valf("ts.val");

int main() {
    sisf >> n;

    for(int i=1; i<=n; i++) {
        tunnel[i] = i;  //kui tunnel puudub, mrgime, et ruudult viib tunnel tema endani
        kaugus[i] = -1; //pole veel teada
    }

    //loeme info tunnelite kohta
    sisf >> ntunnel;
    for(int i=0; i<ntunnel; i++) {
        int sisse, valja;
        sisf >> sisse >> valja;
        tunnel[sisse] = valja;
    }

    //laiuti otsing
    kaugus[1] = 0;
    jkalg = jklopp = 0; //algvrtustame jrjekorra thjana
    jk[jklopp] = 1; jklopp++; //paneme ruudu nr 1 jrjekorda
    while (jklopp > jkalg) { //kuni jrjekord pole thi
        int ruut = jk[jkalg]; jkalg++; //vtame jrjekorrast ruudu
        //vaatame lbi kik ruudud, kuhu sealt pseb
        for(int i = ruut+1; i <= ruut+6 && i <= n; i++) {
            int ruut2 = tunnel[i];
            if(kaugus[ruut2] == -1) { //ruut2 veel lbi vaatamata
                jk[jklopp] = ruut2; jklopp++; //paneme jrjekorda uue ruudu
                //lisame uuele ruudule andmed, kuidas sinna satuti
                kaugus[ruut2] = kaugus[ruut] + 1;
                taring[ruut2] = i - ruut;
                eelm[ruut2] = ruut;
            }
        }
    }

    valf << kaugus[n] << endl;

    //konstrueerime tee, liikudes lpust alguse poole
    int t = 0; //massiivi tee salvestatud tringuvisete arv
    int ruut = n; //alustame lppruudult
    while(ruut > 1) { //ja liigume algruuduni
        tee[t] = taring[ruut];
        t++;
        ruut = eelm[ruut];
    }

    //vljastame tringuvisete tulemused
    for(int i = t-1; i>=0; i--)
        valf << tee[i] << endl;

    sisf.close();
    valf.close();
    return 0;
}
