/* 2006-12-16 programmeerimisvistlus                                       */
/* lesanne: PALINDROOMARVUD                                                */
/* Autor: Margus Niitsoo                                                    */
/* Testitud: GCC 3.2.3 / WinGW32                                            */

#include <stdio.h>
#include <string.h>

#ifdef _WIN32
    #define LONGLONG "%I64d"
#else
    #define LONGLONG "%Ld"
#endif

// Muudab sne palindroomiks, vttes argumendiks puuduva osa pikkuse
void pal(char * in, int mlen)
{
    int len = strlen(in)+mlen, i;

    for(i=0;i<len-mlen;i++)
        in[len-i-1]=in[i];

    for(;i<mlen;i++)
        in[len-i-1]='9';

    in[len]='\0';

    return;
}

int main()
{
    FILE * in, * out;
    char buf[30], low[30], high[30];
    int fp, len, len2, blen;
    long long num, pnum,lnum,hnum; // 64-bitised arvud

    // Loe palindroom snena sisse ja teisenda ta arvuks
    in=fopen("pal.sis","rt");
    fscanf(in,"%s",buf); sscanf(buf,LONGLONG,&num);
    fclose(in);

    // Leia palindroomi esimene pool
    len=strlen(buf);
    len2=(len+1)/2; 
    buf[len2] = '\0';
    sscanf(buf,"%i",&fp);

    // Ehita palindroom sellest esimesest poolest ja tema +-1 -st
    blen=len-len2;
    pal(buf,blen); sscanf(buf,LONGLONG,&pnum);

    if (fp-1==0) low[0]='\0'; else sprintf(low,"%i",fp-1); 
    pal(low,blen); sscanf(low,LONGLONG,&lnum);

    sprintf(high,"%i",fp+1); 
    pal(high,blen); sscanf(high,LONGLONG,&hnum);

    // Vljasta vastus
    out=fopen("pal.val","wt");
    if (pnum<=num) fprintf(out,"%s\n",buf);
    else           fprintf(out,"%s\n",low);
    if (pnum>=num) fprintf(out,"%s\n",buf);
    else           fprintf(out,"%s\n",high);
    fclose(out);

    return 0;
}
