{ 2006-12-16 programmeerimisvistlus                                        }
{ lesanne: PALINDROOMARVUD                                                 }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

{ Efektiivne lahendus }

const
   sisf = 'pal.sis';                                     { sisendfaili nimi }
   valf = 'pal.val';                                    { vljundfaili nimi }

{ vrdleb snedena antud naturaalarve, tagastab a <= b }
function lteq(a, b : string) : boolean;
begin
   if length(a) < length(b) then
      exit(true);
   if length(a) > length(b) then
      exit(false);
   exit(a <= b);
end;

{ vhendab snena antud naturaalarvu he vrra }
procedure decr(var a : string);
var i : integer;
begin
   for i := length(a) downto 2 do
      if a[i] > '0' then begin
         a[i] := pred(a[i]);
         exit;
      end else
         a[i] := '9';
   { nulli vhedamisel saame mittearvu }
   { see pole matemaatiliselt ige, aga meie kontekstis sobib kll }
   a[1] := pred(a[1]);
   { kui vastus pole tpselt null, kustutame algusnulli }
   if a[1] = '0' then
      if length(a) > 1 then
         delete(a, 1, 1);
end;

{ suurendab snena antud naturaalarvu he vrra }
procedure incr(var a : string);
var i : integer;
begin
   for i := length(a) downto 1 do
      if a[i] < '9' then begin
         a[i] := succ(a[i]);
         exit;
      end else
         a[i] := '0';
   { letitumise korral arv pikeneb }
   a := '1' + a;
end;

{ teisendab snena antud naturaalarvu palindroomiks pikkusega m }
procedure pali(var a : string; m : integer);
var i, n : integer;
begin
   n := m - length(a);
   assert(n = length(a) div 2);
   for i := n downto 1 do
      a := a + a[i];
end;

var
   f : text;                                           { sisend/vljundfail }
   n : string;                                                  { antud arv }
   n0, n1, n2 : string;                                      { palindroomid }

begin
   { loeme sisendi }
   assign(f, sisf); reset(f);
   readln(f, n);
   close(f);

   { leiame keskmise palindroomi }
   n1 := copy(n, 1, (length(n) + 1) div 2);
   pali(n1, length(n));

   { leiame viksema palindroomi }
   n0 := copy(n, 1, (length(n) + 1) div 2);
   decr(n0);
   if length(n0) < (length(n) + 1) div 2 then
      pali(n0, length(n) - 1)
   else
      pali(n0, length(n));

   { leiame suurema palindroomi }
   n2 := copy(n, 1, (length(n) + 1) div 2);
   incr(n2);
   if length(n2) > (length(n) + 1) div 2 then
      pali(n2, length(n) + 1)
   else
      pali(n2, length(n));

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   if lteq(n1, n) then writeln(f, n1) else writeln(f, n0);
   if lteq(n, n1) then writeln(f, n1) else writeln(f, n2);
   close(f);
end.
