/* 2006-12-16 programmeerimisvistlus                                       */
/* lesanne: PANK                                                           */
/* Autor: Heno Ivanov                                                       */
/* Testitud: GCC 3.2.3 / WinGW32                                            */

#include <stdio.h>
#include <assert.h>

#define max(a,b) (((a) > (b)) ? (a) : (b))
int kassad[30];
int vabaneb[30];
int K,T;

int leiakassa(aeg,teenus) {
	int kassa;
	int vabax;
	int vaba = -1;
	int i;

	for (i=1;i<=K;i++)
		if ((kassad[i] & (1<<teenus)) != 0) {
			vabax = max(aeg,vabaneb[i]);
			if ((vaba > vabax) || (vaba == -1)) {
				kassa = i;
				vaba = vabaneb[i];
			}
		}
	assert(vaba!=-1);
	return kassa;
}

int main() {
	FILE *sf,*vf;
	int i,j,t,tt;

	sf = fopen("pank.sis","r");
	vf = fopen("pank.val","w");
	assert(sf);
	assert(vf);

	fscanf(sf,"%d %d\n",&K,&T);
	for (i=1;i<=K;i++) {
		fscanf(sf,"%d",&t);
		assert((t>=1)&&(t<=T));
		kassad[i] = 0;
		vabaneb[i] = 0;
		for (j=0;j<t;j++) {
			fscanf(sf,"%d",&tt);
			assert((tt<=T)&&(tt>=1));
			kassad[i] |= (1<<tt);
		}
	}

	fscanf(sf,"%d",&t);
	for (i=0;i<t;i++) {
		int aeg,teenus,kulu,kassa;
		fscanf(sf,"%d %d %d\n",&aeg,&teenus,&kulu);
		kassa = leiakassa(aeg,teenus);
		fprintf(vf,"%d %d\n",kassa,max(aeg,vabaneb[kassa]));
		vabaneb[kassa] = max(aeg,vabaneb[kassa]) + kulu;
	}

	fclose(sf);
	fclose(vf);
	return 0;
}
