{ 2006-12-16 programmeerimisvistlus                                        }
{ lesanne: PREFIKSPAKKIMINE                                                }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

{ Ebaefektiivne lahendus }

const
   sisf = 'pref.sis';                                    { sisendfaili nimi }
   valf = 'pref.val';                                   { vljundfaili nimi }
   maxn = 10000;                                   { maksimaalne snede arv }

var
   f : text;                                           { sisend/vljundfail }
   n : integer;                                                { snede arv }
   a : array [1..maxn] of string;                                   { sned }
   i, j : integer;

{ vahetab massiivi a kaks elementi }
procedure vaheta(i, j : integer);
var s : string;
begin
   s := a[i]; a[i] := a[j]; a[j] := s;
end;

begin
   { loeme sisendi }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, a[i]);
   close(f);

   { sorteerime snede jada vahetusmeetodil -- see ongi ebaefektiive }
   for i := 1 to n do
      for j := i + 1 to n do
         if a[i] > a[j] then
            vaheta(i, j);

   { leiame ja vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, a[1]);                  { esimene sne jb alati muutumatuks }
   for i := 2 to n do begin
      { leiame a[i - 1] ja a[i] hise prefiksi }
      j := 1;
      while true do begin
         if j > length(a[i - 1]) then
            break;
         if j > length(a[i]) then
            break;
         if a[i - 1][j] <> a[i][j] then
            break;
         j := j + 1
      end;
      { a[i - 1] ja a[i] hise prefiksi pikkus on j - 1 }
      if j > 1 then
         write(f, j - 1);
      writeln(f, copy(a[i], j, length(a[i]) - (j - 1)));
   end;
   close(f);
end.
