{ 2006-12-16 programmeerimisvistlus                                        }
{ lesanne: PREFIKSPAKKIMINE                                                }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
   sisf = 'pref.sis';                                    { sisendfaili nimi }
   valf = 'pref.val';                                   { vljundfaili nimi }
   maxn = 10000;                                   { maksimaalne snede arv }

var
   f : text;                                           { sisend/vljundfail }
   n : integer;                                                { snede arv }
   a : array [1..maxn] of string;                                   { sned }
   i, j, k : integer;

{ vahetab massiivi a kaks elementi }
procedure vaheta(i, j : integer);
var s : string;
begin
   s := a[i]; a[i] := a[j]; a[j] := s;
end;

begin
   { loeme sisendi }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, a[i]);
   close(f);

   { muudame jada kuhjaks }
   for i := 1 to n do begin
      j := i;
      while j > 1 do
         if a[j] > a[j div 2] then begin
            vaheta(j, j div 2);
            j := j div 2;
         end else
            j := 1;
   end;
   { muudame kuhja jrjestatud jadaks }
   for i := n downto 1 do begin
      vaheta(1, i);
      j := 1;
      while j < i do begin
         k := j;
         if 2 * j < i then
            if a[2 * j] > a[k] then
               k := 2 * j;
         if 2 * j + 1 < i then
            if a[2 * j + 1] > a[k] then
               k := 2 * j + 1;
         if k > j then begin
            vaheta(j, k);
            j := k;
         end else
            j := i;
      end;
   end;

   { leiame ja vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, a[1]);                  { esimene sne jb alati muutumatuks }
   for i := 2 to n do begin
      { leiame a[i - 1] ja a[i] hise prefiksi }
      j := 1;
      while true do begin
         if j > length(a[i - 1]) then
            break;
         if j > length(a[i]) then
            break;
         if a[i - 1][j] <> a[i][j] then
            break;
         j := j + 1
      end;
      { a[i - 1] ja a[i] hise prefiksi pikkus on j - 1 }
      if j > 1 then
         write(f, j - 1);
      writeln(f, copy(a[i], j, length(a[i]) - (j - 1)));
   end;
   close(f);
end.
